import copy
class Objet:
    def __init__(self, poids, valeur):
        self.poids = poids
        self.valeur = valeur
        self.pris = False

    def __repr__(self):
        return "poids : " + str(self.poids) + " valeur : " + str(self.valeur) + " pris : " + str(self.pris) 


def mettreDansSac(sac,id):
    obj = sac[id]
    obj.pris = True


def retireDuSac(sac,id):
    obj = sac[id]
    obj.pris = False

def estPris(sac,id):
    return sac[id].pris


def poidsTotal(sac):
    s = 0
    for i in sac:
        if i.pris:
            s += i.poids
    return s

def valeurTotale(sac):
    s = 0
    for i in sac:
        if i.pris:
            s += i.valeur
    return s


def printSac(sac):
    st = "poids total : " + str(poidsTotal(sac)) + "\n["
    for i in sac:
        if i.pris:
            st += str(i) + "; "
    st += "]"
    print(st)


def pbsacados(sac, capacite):
    def inter(sac, capacite, meilleurSac):
        for obj in filter(lambda x: not x.pris, sac):
            if  capacite == obj.poids:
                obj.pris = True
                return copy.deepcopy(sac)
            elif capacite > obj.poids:
                obj.pris = True
                inter(sac,capacite-obj.poids,meilleurSac)
                if valeurTotale(meilleurSac) < valeurTotale(sac):
                    meilleurSac = copy.deepcopy(sac)
                obj.pris = False
        return meilleurSac

    return inter(sac,capacite,copy.deepcopy(sac))
    

sac = [Objet(6,10), Objet(4,90), Objet(3,3), Objet(2,2)]
capacite = 7

reponse = pbsacados(sac,capacite)
printSac(reponse)